﻿    //========================================================================
    //                         Geometry Libraly
    //========================================================================
    /*  P:=Property Value (คุณสมบัติ) ; 
        F:=Function Return Value (การทำงานที่ไม่มีผลกระทบต่อคุณสมบัติ ได้รับผลลัพทธ์) ; 
        M:=Method Return True False (การทำงานที่ก่อให้เกิดการเปลี่ยนคุณสมบัติ ได้รับผล true,false);
        E:=Event Release if not null (ทำชุดคำสั่งนี้หลักจากทำชุดคำสั่ง Method ถ้ามี);
    */
    //------------------------------------------------------------------------
    // Point Construction
    //------------------------------------------------------------------------
    function Point(x,y){
        /*P*/this.X = parseFloat(x);
        /*P*/this.Y = parseFloat(y);
        /*F*/this.toString = Point_toString;
        /*F*/this.AsRect = Point_AsRect;
        /*F*/this.Clone = Point_Clone;
        /*F*/this.Offset = Point_Offset;
        /*F*/this.Different = Point_Different;
        /*F*/this.Distance = Point_Distance;
        /*F*/this.Rescale = Point_Rescale;
        /*M*/this.Move = Point_Move;
        /*M*/this.MoveTo = Point_MoveTo;
        /*M*/this.SetX = Point_SetX;
        /*M*/this.SetY = Point_SetY;
        /*M*/this.SetXY = Point_SetXY;
        /*E*/this.OnMove = new Function('sender','return null');
    }
       /*F*/function Point_Clone(){
         return new Point(this.X,this.Y);
        }
       /*F*/function Point_toString(){
         return "Point{"+this.X+","+this.Y+"}";
       }
       /*F*/function Point_AsRect(){
         return new Rect(0,0,this.X,this.Y);
       }
       /*F*/function Point_Different(OtherPoint){
         var OffsetX = OtherPoint.X - this.X;
         var OffsetY = OtherPoint.Y - this.Y;
         return new Point(OffsetX,OffsetY);
       }
       /*F*/function Point_Offset(OtherPoint){
         var OffsetX = OtherPoint.X + this.X;
         var OffsetY = OtherPoint.Y + this.Y;
         return new Point(OffsetX,OffsetY);
       }
       /*F*/function Point_Rescale(Scale){
         var NewX = this.X * Scale;
         var NewY = this.Y * Scale;
         return new Point(NewX,NewY);
       }
       /*F*/function Point_Distance(OtherPoint){
        var Diff = this.Offset(OtherPoint);
        return Math.sqrt((Diff.X*Diff.X)+(Diff.Y*Diff.Y));
       }
       /*M*/function Point_Move(Distance){ /*M*/
        var Move = this.Offset(Distance);
        this.X = Move.X;
        this.Y = Move.Y;
        if (this.OnResize!=null){this.OnResize()};
       }
       /*M*/function Point_MoveTo(NewPoint){
        this.SetX(NewPoint.X);
        this.SetY(NewPoint.Y);
        if (this.OnMove!=null){this.OnMove()};
       }
       /*M*/function Point_SetX(NewX){
        this.X = NewX;
        if (this.OnMove!=null){this.OnMove()};
       }
       /*M*/function Point_SetY(NewY){
        this.Y = NewY;
        if (this.OnMove!=null){this.OnMove()};
       }
       /*M*/function Point_SetXY(NewX,NewY){
        this.SetX(NewX);
        this.SetY(NewY);
        if (this.OnMove!=null){this.OnMove()};
       }
    //----------------------------------------------
    // Rectangular Construction
    //----------------------------------------------
    function Rect(Xmin,Ymin,Xmax,Ymax){
        /*P*/this.Xmin = Math.min(parseFloat(Xmin),parseFloat(Xmax));
        /*P*/this.Xmax = Math.max(parseFloat(Xmin),parseFloat(Xmax));
        /*P*/this.Ymax = Math.max(parseFloat(Ymin),parseFloat(Ymax));
        /*P*/this.Ymin = Math.min(parseFloat(Ymin),parseFloat(Ymax));
        /*F*/this.Clone = Rect_Clone;
        /*F*/this.toString = Rect_toString;
        /*F*/this.Width  = Rect_Width;
        /*F*/this.Height = Rect_Height;
        /*F*/this.Size   = Rect_Size;
        /*F*/this.Center = Rect_Center;
        /*F*/this.PointN = Rect_PointN;
        /*F*/this.PointS = Rect_PointS;
        /*F*/this.PointW = Rect_PointW;
        /*F*/this.PointE = Rect_PointE;
        /*F*/this.PointNE = Rect_PointNE;
        /*F*/this.PointNW = Rect_PointNW;
        /*F*/this.PointSE = Rect_PointSE;
        /*F*/this.PointSW = Rect_PointSW;
        /*F*/this.PointMin = Rect_PointSW;
        /*F*/this.PointMax = Rect_PointNE;
        
        /*M*/this.Rescale = Rect_Rescale;
        /*F*/this.Different = Rect_Different;
        /*F*/this.Offset = Rect_Offset;
        /*E*/this.OnResize = new Function('sender','return null');
        /*E*/this.OnMove = new Function('sender','return null');
    }
        /*F*/function Rect_Clone(){
            return new Rect(this.Xmin,this.Ymin,this.Xmax,this.Ymax);
        }
        /*F*/function Rect_toString(){
            if (arguments.length==0){
                return "Rect{"+this.Xmin+","+this.Ymin+","+this.Xmax+","+this.Ymax+"}";
            }else{
               Separate = arguments[0];
               return this.Xmin+Separate+this.Ymin+Separate+this.Xmax+Separate+this.Ymax;
            }
        }
        /*F*/function Rect_Width(){
            return this.Xmax - this.Xmin;
        }
        /*F*/function Rect_Height(){
            return this.Ymax - this.Ymin;
        }
        /*F*/function Rect_Size(){
            return new Point(this.Width(),this.Height());
        }
        /*F*/function Rect_Center(){
            return new Point(this.Xmin+(this.Width()/2),this.Ymin+(this.Height()/2))
        }
        /*F*/function Rect_PointN(){
            return new Point(this.Center().X,this.Ymax);
        }
        /*F*/function Rect_PointS(){
            return new Point(this.Center().X,this.Ymin);
        }
        /*F*/function Rect_PointE(){
            return new Point(this.Xmax,this.Center().Y);
        }
        /*F*/function Rect_PointW(){
            return new Point(this.Xmin,this.Center().Y);
        }
        /*F*/function Rect_PointNE(){
            return new Point(this.Xmax,this.Ymax);
        }
        /*F*/function Rect_PointNW(){
            return new Point(this.Xmin,this.Ymax);
        }
        /*F*/function Rect_PointSE(){
            return new Point(this.Xmax,this.Ymin);
        }
        /*F*/function Rect_PointSW(){
            return new Point(this.Xmin,this.Ymin);
        }
        /*M*/function Rect_Rescale(){
            if (arguments.lenght<1){return null};
            if (arguments.length>1)
            {
                Center=arguments[1];
            }else{
                Center=this.Center();
            }
            var Scale = arguments[0]/2; 
            var Left = Center.X - (this.Width()*Scale);
            var Right = Center.X + (this.Width()*Scale);
            var Top = Center.Y + (this.Height()*Scale);
            var Bottom = Center.Y - (this.Height()*Scale);
            this.Xmin = Left;
            this.Ymin = Bottom;
            this.Xmax = Right;
            this.Ymax = Top;
            if (this.OnResize!=null){this.OnResize()};
        }
        /*F*/function Rect_Different(OtherRect){
            //Calculate Different Two Rect in Ratio (0-1);
            var Left = OtherRect.Xmin - this.Xmin;
            var Right = OtherRect.Xmax - this.Xmax;
            var Top = OtherRect.Ymax - this.Ymax;
            var Bottom = OtherRect.Ymin - this.Ymin;
            return new Rect(Left/this.Width(),Bottom/this.Height(),
                            Right/this.Width(),Top/this.Height());
        }
        
        /*M*/function Rect_Offset(MapOffset){
            this.Xmin += MapOffset.X;
            this.Ymin += MapOffset.Y;
            this.Xmax += MapOffset.X;
            this.Ymax += MapOffset.Y;
            if (this.OnMove!=null){this.OnMove()};
        }
    //----------------------------------------------
    function Line(StartPoint,EndPoint){
        this.Start = StartPoint;
        this.End = EndPoint;
        this.Length = Math.sqrt(Math.pow(this.Start.X-this.End.X,2)
                               +Math.pow(this.Start.Y-this.End.Y,2));
        this.Extent = new Rect(this.Start.X,this.Start.Y,this.End.X,this.End.Y)
        this.Center = this.Extent.Center();
        this.toString = this.Start.X+","+this.Start.Y+","+this.End.X+","+this.End.Y;
        this.Clone = Line_Clone;
    }
        function Line_Clone(){
            return Line(this.Start.Clone(),this.End.Clone());
        }
    //-------------------------------------------------
    function Polyline(PointArray){
        if (PointArray==null) PointArray = new Array();
        this.Points = PointArray;
        this.Start = PointArray[0];
        this.End = PointArray[PointArray.length-1];
        Polyline.AddPoint = Polyline_AddPoint;
        Polyline.AddList = Polyline_AddList;
        Polyline.Join = Polyline_Join;
        Polyline.RemoveLast = Polyline_RemoveLast;
        Polyline.Reverse = Polyline_Reverse;
        Polyline.toString = Polyline_toString;
        Polyline.Length = Polyline_Length;
        Polyline.Clone = Polyline_Clone;
    }
        function Polyline_Clone(){
            Result = new Polyline;
            for (i=0;i<this.Points.length;i++){
                pClone = this.Points[i].Clone();
                Result.AddPoint(pClone);
            }
            return Result;
        }
        function Polyline_AddPoint(aPoint){
            this.Points[this.Points.length] = aPoint;
            this.End = aPoint;
        }
        function Polyline_AddList(aPointList){
            this.Points.push(aPointList);
            this.End = aPointList[aPointList.length-1];
        }
        function Polyline_Join(aPolyline){
            this.Points.join(aPolyline);
            this.End = aPolyline.End;
        }
        function Polyline_RemoveLast(){
            this.Points.pop();
        }
        function Polyline_Reverse(){
            this.Points.reverse();
            this.Start = this.Points[0];
            this.End = this.Points[this.Points.length-1];
        }
        function Polyline_toString(){
            var List = this.Points[0].X + ","+this.Points[0].Y;
            for (i=1;i<this.Points.length;i++) {
                List = List + " " + this.Points[i].X + ","+ this.Points[i].Y;
            }
            return(List);
        }
        function Polyline_Length(){
            Length = 0;
            StartPoint = this.Points[0];
            for (i=1;i<this.Points.length;i++) {
                EndPoint = this.Points[i];
                aLine = new Line(StartPoint,EndPoint);
                Length = Length + aLine.Length;
                StartPoint = EndPoint;
            }
            return(Length);
        }
    //=========================== Polygon Construct ======================
    function Polygon(PointArray){
        if (PointArray==null) PointArray = new Array();
        this.Points = PointArray;
        this.Start = PointArray[0];
        this.End = PointArray[PointArray.length-1];
        Polygon.AddPoint = Polygon_AddPoint;
        Polygon.AddList = Polygon_AddList;
        Polygon.Join = Polygon_Join;
        Polygon.RemoveLast = Polygon_RemoveLast;
        Polygon.Reverse = Polygon_Reverse;
        Polygon.toString = Polygon_toString;
        Polygon.Perimeter = Polygon_Perimeter;
        Polygon.Area = Polygon_Area;
        Polygon.Clone = Polygon_Clone;
    }
        function Polygon_Clone(){
            Result = new Polyline;
            for (i=0;i<this.Points.length;i++){
                pClone = this.Points[i].Clone();
                Result.AddPoint(pClone);
            }
            return Result;
        }
        function Polygon_AddPoint(aPoint){
            this.Points[this.Points.length] = aPoint;
            this.End = aPoint;
        }
        function Polygon_AddList(aPointList){
            this.Points.push(aPointList);
            this.End = aPointList[aPointList.length-1];
        }
        function Polygon_Join(aPolygon){
            this.Points.join(aPolygon);
            this.End = aPolyline.End;
        }
        function Polygon_RemoveLast(){
            this.Points.pop();
        }
        function Polygon_Reverse(){
            this.Points.reverse();
            this.Start = this.Points[0];
            this.End = this.Points[this.Points.length-1];
        }
        function Polygon_toString(){
            var List = this.Points[0].X + ","+this.Points[0].Y;
            for (i=1;i<this.Points.length;i++) {
                List = List + " " + this.Points[i].X + ","+ this.Points[i].Y;
            }
            return(List);
        }
        function Polygon_Line(){
            Length = 0;
            StartPoint = this.Points[0];
            for (i=1;i<this.Points.length;i++) {
                EndPoint = this.Points[i];
                aLine = new Line(StartPoint,EndPoint);
                Length = Length + aLine.Length;
                StartPoint = EndPoint;
            }
            return(Length);
        }
        function Polygon_Perimeter(){
            thisLength = 0;
            for (i=0;i<this.Points.length;i++) {
                thisPoint = this.Points[i];
                if (i==0){
                    lastPoint = this.Points[this.Points.length-1]
                }else{
                    lastPoint = this.Points[i-1]
                }
                thisWidth = thisPoint.X-lastPoint.X;
                thisHeight = this.Point.Y-lastPoint.Y;
                thisLength += Math.sqrt(Math.pow(2,thisWidth)+Math.pow(2,thisHeight));
            }
            return thisLength; 
        }
        function Polygon_Area(){
            thisArea = 0;
            for (i=0;i<this.Points.length;i++) {
                thisPoint = this.Points[i];
                if (i==0){lastPoint = this.Points[this.Points.length-1]
                }else{
                    lastPoint = this.Points[i-1]
                }
                thisArea += (((thisPoint.Y+lastPoint.Y)*(thisPoint.X-lastPoint.X))/2)
            }
            return thisArea; //Sum_Area;
        }
