﻿    //========================================================================
    //                   MapServ Object Class Construct
    //========================================================================
    
    function Layer(Name,Group, Visible, Selectable, Queryable) 
    {
     this.Id = null;
     this.Name = Name;
     this.Group = Group;
     this.Title = "";
     this.Abstract = "";
     this.Extent = new Rect(-180,-90,180,90);
     this.SRS = new Array();
     this.Styles = new Array();
     this.Style = "default";
     this.Type = "";
     this.Fields = null;
     this.Renderer = null;
     this.Cascaded = false;
     this.Opaque = false;
     this.Visible = Visible;
     this.Selectable = Selectable;
     this.Queryable = Queryable;
     this.Active = false;
    }
    //----------------------------------------------------------
    function MapScript(ServerURL){
        this.GCTP = new gctp();
        this.XML = new XMLUtil();
        this.ReferenceMap = null;
        this.MapControl = null;
        this.Syntax = "WMS";
       
        //---------
        this.SRS = "EPSG:4326";
        this.Version = "1.1.1";
        this.GetMapFormat = null;//"image/png; mode=24bit";
        this.GetCapFormat = "text/xml";
        
        this.SRSs = new Array();
        this.GetMapFormats = new Array();
        //---------
        this.Unit = "DD";
        this.PixelsPerInch = 72;
        this.InchesPerUnit = 39.37007874;

        this.MapServer = ServerURL;
        this.MapOptions = null;
        this.QueryServer = null;
        this.QueryOptions = null;

        this.History = new History();
        this.Layers = new Array();
        this.LayerLimit = 25;
        this.ImgSize = null;
        this.DefaultExtent = null;
        this.Extent =  null;
        this.ZoomScale = 2; 
        this.MinScale = -1;
        this.MaxScale = -1;
        
        this.UserShape = null;
        this.QueryShape = null;
        this.EditShape = null;
        this.SpatialString = null;
        this.SpatialExtent = null;
        this.SpatialShape = null;

        this.SetSRS = MapScript_SetSRS;

        this.Styles = MapScript_Styles;
        this.GetLayerActive = MapScript_GetLayerActive;
        this.SetLayerActive = MapScript_SetLayerActive;
        this.SetLayerVisible = MapScript_SetLayerVisible;
        this.SetLayerSelectable = MapScript_SetLayerSelectable;
        this.SetLayerQueryable = MapScript_SetLayerQueryable;

        this.CellSize = MapScript_CellSize;
        this.MapScale = MapScript_MapScale;
        
        this.SetImgSize = MapScript_SetImgSize;
        this.SetExtent = MapScript_SetExtent;
        this.AdjustExtent = MapScript_AdjustExtent;

        this.ImgWidthInMapUnit = MapScript_ImgWidthInMapUnit;
        this.ImgHeightInMapUnit = MapScript_ImgHeightInMapUnit;
        this.ImgPositionX = MapScript_ImgPositionX;
        this.ImgPositionY = MapScript_ImgPositionY;
        this.ImgPosition = MapScript_ImgPosition;
        
        this.MapPositionX = MapScript_MapPositionX;
        this.MapPositionY = MapScript_MapPositionY;
        this.MapPosition = MapScript_MapPosition;
        this.MapLocation = MapScript_MapLocation;
        
        this.ZoomToScale = MapScript_ZoomToScale;
        this.ZoomToImgCenter = MapScript_ZoomToImgCenter;
        this.ZoomToMapCenter = MapScript_ZoomToMapCenter;
        this.ZoomToImgExtent = MapScript_ZoomToImgExtent;
        this.ZoomToMapExtent = MapScript_ZoomToMapExtent;

        this.PanToImgCenter = MapScript_PanToImgCenter;
        this.PanToMapCenter = MapScript_PanToMapCenter;
        this.PanToDirection = MapScript_PanToDirection;
        
        this.VLayers = MapScript_VLayers; // Map Layer
        this.SLayers = MapSript_SLayers; // Select Layer
        this.QLayers = MapSript_QLayers; // Query Layer
        //Set Invisible All Layer Under The Opaque Layer Id or Name;
        this.InvisibleUnderLayer = MapScript_InvisibleUnderLayer;
        //----------------
        //Method Depend on Connector
        //OnLoad Must Assign Outside Here Before LoadCap
        this.OnLoadCapabilities = null; 
        this.LoadCapabilities = WMS_LoadCapabilities;
        this.Capabilities = null;
        this.CapabilitiesHeader = null;
        //----------------
        this.OverviewSize = new Point(250,200);
        this.GetMap = WMS_GetMap; 
        this.GetOverview = WMS_GetOverview;
        this.GetLegendGraphic = WMS_GetLegendGraphic;
        this.GetFeatureInfo = WMS_GetFeatureInfo;
        this.GetCapabilities = WMS_GetCapabilities;
        this.AutoMapFormat = WMS_AutoMapFormat;
        //----------------
    }

        function MapScript_SetSRS(NewSRS){
            var NewProj = this.GCTP.getProjection(NewSRS);
            if (NewProj==false){//Do Nothing
                alert('Map projection '+NewSRS+' is undefined');
                return NewProj;
            }
            var NewLL = this.GCTP.projectCoordinates(this.Extent.Xmin,this.Extent.Ymin,this.SRS,NewSRS);
            var NewUR = this.GCTP.projectCoordinates(this.Extent.Xmax,this.Extent.Ymax,this.SRS,NewSRS);
            var NewExt = new Rect(NewLL[0],NewLL[1],NewUR[0],NewUR[1]);
            this.SetExtent(NewExt);
            this.SRS = NewSRS;
            return NewProj;
        }

        function MapScript_GetLayerActive(){
            if (this.Layers==null || typeof this.Layers.length != 'number')
                {this.Layers = new Array();}
            for (i=0;i<this.Layers.length;i++){
                if (this.Layers[i].Active){
                    return this.Layers[i];
                }
            }
            return null;
        }

        function MapScript_SetLayerActive(LayerName){
            if (this.Layers==null || typeof this.Layers.length != 'number')
                {this.Layers = new Array();}
            for (i=0;i<this.Layers.length;i++){
                if (this.Layers[i].Name==LayerName){
                    lessOneActive = true
                    this.Layers[i].Active=true
                }else{
                    this.Layers[i].Active=false
                }
            }
            if ((!lessOneActive)&&(this.Layers.length>0)){this.Layers[0].Active=true}
        }

        function MapScript_SetLayerVisible(LayerName,Visible){
            if(typeof(Visible)=="string"){
                if (Visible=="true"){Visible=true}else{Visible=false};
            }
            for (i=0;i<this.Layers.length;i++){
                if (this.Layers[i].Name==LayerName) this.Layers[i].Visible=Visible
            }
        }
        function MapScript_SetLayerSelectable(LayerName,Selectable){
            if(typeof(Visible)=="string") Visible = eval(Visible);
            for (i=0;i<this.Layers.length;i++){
                if (this.Layers[i].Name==LayerName) this.Layers[i].Selectable=Selectable
            }
        }
        function MapScript_SetLayerQueryable(LayerName,Queryable){
            if(typeof(Visible)=="string") Visible = eval(Visible);
            for (i=0;i<this.Layers.length;i++){
                if (this.Layers[i].Name==LayerName) this.Layers[i].Queryable=Queryable
            }
        }

        function MapScript_CellSize(){
            if (this.Extent==null){return null;}
            return Math.max(this.Extent.Width()/this.ImgSize.X,
                            this.Extent.Height()/this.ImgSize.Y);
        }

        function MapScript_MapScale(){
            return(this.Extent.Width()/this.ImgWidthInMapUnit());
        }

        function MapScript_SetImgSize(Size){
            this.ImgSize = Size;
        }
        function MapScript_SetExtent(extent){
            this.Extent = this.AdjustExtent(extent);;
        }
        function MapScript_AdjustExtent(MapExtent,ImgSize){
            //Use only fisttime for adjust incorrect extent
            if (typeof MapExtent=="undefined") {return this.Extent};
            if (typeof ImgSize=="undefined") {ImgSize = this.ImgSize};

            CellSize = Math.max(MapExtent.Width()/ImgSize.X,
                                MapExtent.Height()/ImgSize.Y);
            var adjextent = new Rect(MapExtent.Center().X - CellSize*ImgSize.X*0.5,
                                     MapExtent.Center().Y - CellSize*ImgSize.Y*0.5,
                                     MapExtent.Center().X + CellSize*ImgSize.X*0.5,
                                     MapExtent.Center().Y + CellSize*ImgSize.Y*0.5);
            return(adjextent);
        }
        
        function MapScript_ImgWidthInMapUnit(){
            return((this.ImgSize.X)/(this.PixelsPerInch*this.InchesPerUnit))
        }
        
        function MapScript_ImgHeightInMapUnit(){
            return((this.ImgSize.Y)/(this.PixelsPerInch*this.InchesPerUnit))
        }
        
        function MapScript_ImgPositionX(X){
            return((X-this.Extent.Xmin)/this.CellSize());
        }

        function MapScript_ImgPositionY(Y){
            return((this.Extent.Ymax-Y)/this.CellSize())    
        }
        
        function MapScript_ImgPosition(Coordinate){
            return(new Point(this.ImgPositionX(Coordinate.X),
                             this.ImgPositionY(Coordinate.Y)));
        }

        function MapScript_MapPositionX(x){
            return(this.Extent.Xmin + (this.CellSize()*x));
        }
        
        function MapScript_MapPositionY(y){
            return(this.Extent.Ymax - (this.CellSize()*y))
        }
        
        function MapScript_MapPosition(coordinate){
            return(new Point(this.MapPositionX(coordinate.X),
                             this.MapPositionY(coordinate.Y)));
        }
        
        function MapScript_MapLocation(extent){
            return(new Rect(this.MapPositionX(extent.Xmin),
                            this.MapPositionY(extent.Ymin),
                            this.MapPositionX(extent.Xmax),
                            this.MapPositionY(extent.Ymax)));    
        }
        //----------------------------
        function MapScript_ZoomToScale(scale){
            this.Extent.Rescale(1/scale);
            this.Extent = this.AdjustExtent(this.Extent.Clone());
        }

        function MapScript_ZoomToImgExtent(){
            switch(arguments.length){
                case 0: this.ZoomToMapExtent();break;
                case 1: this.ZoomToMapExtent(this.MapLocation(arguments[0]));break;
                case 4: 
                    var ImgExt = new Rect(arguments[0],arguments[1],arguments[2],arguments[3]);
                    var MapExt = this.MapLocation(ImgExt);
                    this.ZoomToMapExtent(MapExt);
                    break;
                default : 
                    alert('Invalid argument ZoomToImgExtent\n'+
                          'Usege: ZoomToImgExtent()\n'+
                          '       ZoomToImgExtnet(Rect)\n'+
                          '       ZoomToImgExtent(Xmin,Ymin,Xmax,Ymax)');
                    break;
            }
        }
        function MapScript_ZoomToMapExtent(){
            switch (arguments.length){
                case 0 : 
                    if (this.DefaultExtent==null){
                        alert('Can\'t do ZoomToExtent function\n'+
                              'Default Map Extent Not Set');
                        return null;
                    }
                    var NewLL = this.GCTP.projectCoordinates(this.DefaultExtent.Xmin,this.DefaultExtent.Ymin,"EPSG:4326",this.SRS);
                    var NewUR = this.GCTP.projectCoordinates(this.DefaultExtent.Xmax,this.DefaultExtent.Ymax,"EPSG:4326",this.SRS);
                    var NewExt = new Rect(NewLL[0],NewLL[1],NewUR[0],NewUR[1]);
                    this.Extent = this.AdjustExtent(NewExt); 
                    break;
                case 1 : 
                    this.Extent = this.AdjustExtent(arguments[0]);
                    break;
                case 4 : 
                    NewExtent = new Rect(arguments[0],arguments[1],arguments[2],arguments[3]);
                    this.Extent = this.AdjustExtent(NewExtent);
                    break;
                default : 
                    alert('Invalid argument ZoomToMapExtent\n'+
                          'Usege: ZoomToMapExtent()\n'+
                          '       ZoomToMapExtnet(Rect)\n'+
                          '       ZoomToMapExtent(Xmin,Ymin,Xmax,Ymax)');
                    break;
            }
        }
        //--------------------------
        function MapScript_ZoomToImgCenter(center,scale){
            switch (arguments.length){
                case 0:
                    center= this.Extent.Center();
                    scale = this.ZoomScale;
                    break;
                case 1:
                    center= this.MapPosition(center);
                    scale = this.ZoomScale;
                    break;
                case 2:
                    center= this.MapPosition(center);
                    scale = scale;
                    break;
                default:
                    return null;
                    break;
            }
            this.PanToMapCenter(center);
            this.ZoomToScale(scale);
        }
        
        function MapScript_ZoomToMapCenter(center,scale){
            switch (arguments.length){
                case 0:
                    center= this.Extent.Center();
                    scale = this.ZoomScale;
                    break;
                case 1:
                    center= center;
                    scale = this.ZoomScale;
                    break;
                case 2:
                    center= center;
                    scale = scale;
                    break;
                default:
                    return null;
                    break;
            }
            this.PanToMapCenter(center);
            this.ZoomToScale(scale);
        }
        //------------------------------------------
        function MapScript_PanToImgCenter(){
            switch (arguments.length){
                case 1: //Pan To Center
                    FromMapPoint = this.MapPosition(arguments[0]);
                    ToMapPoint = this.Extent.Center();
                    break;
                case 2: //Pan From One Location To Another
                    FromMapPoint = this.MapPosition(arguments[0]);
                    ToMapPoint = this.MapPosition(arguments[1]);
                    break;
                default:
                    alert('Invalid Arguments PanImg\n'+
                          'Usege: PanMap(ToCenterMapPoint)\n'+
                          '       PanMap(FromMapPoint,ToMapPoint)\n');
                    return null;
                    break;
            }
            MapOffset = ToMapPoint.Different(FromMapPoint);
            this.Extent.Offset(MapOffset);
        }
        function MapScript_PanToMapCenter(){
            switch (arguments.length){
                case 1: //Pan To Center
                    FromMapPoint = arguments[0];
                    ToMapPoint = this.Extent.Center();
                    break;
                case 2: //Pan From One Location To Another
                    FromMapPoint = arguments[0];
                    ToMapPoint = arguments[1];
                    break;
                default:
                    alert('Invalid Arguments PanMap\n'+
                          'Usege: PanMap(ToCenterMapPoint)\n'+
                          '       PanMap(FromMapPoint,ToMapPoint)\n');
                    return null;
                    break;
            }
            MapOffset = ToMapPoint.Different(FromMapPoint);
            this.Extent.Offset(MapOffset);
        }
        
        
        function MapScript_PanToDirection(Direction){
            switch (Direction){
                case "N"  :    this.PanToMapCenter(this.Extent.PointN()); break;
                case "S"  :    this.PanToMapCenter(this.Extent.PointS()); break;
                case "E"  :    this.PanToMapCenter(this.Extent.PointE()); break;
                case "W"  :    this.PanToMapCenter(this.Extent.PointW()); break;
                case "NE" :    this.PanToMapCenter(this.Extent.PointNE()); break;
                case "NW" :    this.PanToMapCenter(this.Extent.PointNW()); break;
                case "SE" :    this.PanToMapCenter(this.Extent.PointSE()); break;
                case "SW" :    this.PanToMapCenter(this.Extent.PointSW()); break;
                default : break;
            }
        }

        //----------------------------------------------------

        function MapScript_VLayers(Separate){
             if (this.Layers==null){return '';}
             if (typeof this.Layers.length != 'number'){return '';}
             if (this.Layers.length==0){return '';}
             var LayerList = '';
             for(var i=0; i<this.Layers.length; i++) {
                 if(this.Layers[i].Visible) {
                     if(LayerList == '') 
                        LayerList = this.Layers[i].Name;
                     else
                        LayerList = LayerList + Separate + this.Layers[i].Name;
                 }
             }
             return LayerList;
        }
        function MapSript_SLayers(Separate){
             if (this.Layers==null){return '';}
             if (typeof this.Layers.length != 'number'){return '';}
             if (this.Layers.length==0){return '';}
             var LayerList = '';
             for(var i=0; i<this.Layers.length; i++) {
                 if(this.Layers[i].Selectable) {
                     if(LayerList == '') 
                        LayerList = this.Layers[i].Name;
                     else
                        LayerList = LayerList+Separate+this.Layers[i].Name;
                 }
             }
             return(LayerList);
        }
        function MapSript_QLayers(Separate){
             if (this.Layers==null){return '';}
             if (typeof this.Layers.length != 'number'){return '';}
             if (this.Layers.length==0){return '';}
             var LayerList = '';
             for(var i=0; i<this.Layers.length; i++) {
                 if(this.Layers[i].Queryable) {
                     if(LayerList == '') 
                        LayerList = this.Layers[i].Name;
                     else
                        LayerList = LayerList+Separate+this.Layers[i].Name;
                 }
             }
             return(LayerList);
        }
        
        function MapScript_Styles(Separate){
             if (this.Layers==null){return '';}
             if (typeof this.Layers.length != 'number'){return '';}
             if (this.Layers.length==0){return '';}
             var LayerList = '';
             for(var i=0; i<this.Layers.length; i++) {
                 if(this.Layers[i].Style!=null&&this.Layers[i].Visible) {
                     if(LayerList == '') 
                        LayerList = this.Layers[i].Style;
                     else
                        LayerList = LayerList+Separate+this.Layers[i].Style;
                 }
             }
             return(LayerList);
        }

        function MapScript_InvisibleUnderLayer(ID_Or_Name){
             if (this.Layers==null){return null;}
             if (this.Layers.length==0){return '';}
             //if (typeof ID_Or_Name == 'number'){ID_Or_Name=this.Layers[ID_Or_Name];}
             LayerID = ID_Or_Name; //กำลังพัฒนาให้รองรับ LayerName
             for(var i=0; i<LayerID; i++) {
                 this.Layers[i].Visible = false;
             }
        }
        
//============================================================
//                  WMS Connector 
//============================================================
    function WMS_GetCapabilities(){
        var Extra = this.MapServer.indexOf('?')<0?'?':'';
        var Request  = this.MapServer+Extra;
            Request += '&Service=WMS&Version='+this.Version;
            Request += '&Request=GetCapabilities&Format=text/xml';
        //prompt('',Request);
        return Request;
    }
    //-------------------------------------
    function WMS_GetOverview(){
        return this.GetMap(this.OverviewSize,this.AdjustExtent(this.Extent,this.OverviewSize));
    }
    function WMS_GetMap(ImgSize,MapExtent){
        if (arguments.length<1){ImgSize = this.ImgSize};
        if (arguments.length<2){MapExtent = this.Extent};
        
        if(this.VLayers(',')==""){return "GISTDA.JScript/Spacer.gif"};
        var Extra = this.MapServer.indexOf('?')<0?'?':'';
        var Request =  this.MapServer+Extra;
            Request += '&Service=WMS';
            Request += '&Version='+this.Version;
            Request += '&Request=GetMap';
            Request += '&Exceptions=application/vnd.ogc.se_inimage';
            //Request += '&Transparent=True';
            Request += this.SRS==null?'':'&SRS='+this.SRS;
            Request += this.GetMapFormat==null?'&Format=image/png':'&Format='+this.GetMapFormat;
            Request += this.Layers==null?'&Layers=':'&Layers='+this.VLayers(',');
            Request += this.Styles==null?'&Styles=':'&Styles='+this.Styles(',');
            Request += ImgSize==null?'&Width=1024':'&Width='+ImgSize.X;
            Request += ImgSize==null?'&Height=768':'&Height='+ImgSize.Y;
            Request += MapExtent==null?'&BBOX=-180,-90,180,90':'&BBOX='+MapExtent.toString(',');
            //Request += '&Map_Interlace=OFF';
            //Request += '&Map_ImageType=JPEG';
            if (this.MapOptions!=null){
                Request =    Request + this.MapOptions
            }
        //prompt('',Request);
        return(Request);
    }
    //-------------------------------------
    function WMS_GetLegendGraphic(LayerName){
        var Extra = this.MapServer.indexOf('?')<0?'?':'';
        if (this.Layers==null){return null;}
        var Request =  this.MapServer+Extra;
            Request += '&Service=WMS';
            Request += '&Version='+this.Version;
            Request += '&Request=GetLegendGraphic';
            Request += this.GetMapFormat==null?'&Format=image/jpeg':'&Format='+this.GetMapFormat;
            Request += '&Layer='+LayerName;
        return Request;
    }
    //-------------------------------------
    function WMS_LoadCapabilities(OnLoadFunction){
        this.OnLoadCapabilities = OnLoadFunction;
        this.XML.Load(this.GetCapabilities(),WMS_OnLoadCapabilities,this);
    }
    //-------------------------------------
    //This is internal function after load capabilities
    //Must define MapScript.OnLoadCapabilities before call this function
    function WMS_OnLoadCapabilities(XMLHttp,Map){
        if (XMLHttp.readyState!=4) {return null;}
        switch (XMLHttp.status){
            case 200 : break; // Status OK Do Next Step
            //case 404 : alert("URL doesn't exist!"); return null; break;
            default  : alert(Map.GetCapabilities()+ "\n------------------------------------------------\n" +
                             "HttpRequest Status "+XMLHttp.status+" :: "+XMLHttp.statusText); return null; break;
        }
        //###prompt("Map Capabilities URL",Map.GetCapabilities());
        //~~~~~~~~~~~~~~~~~~~~~~~~~
        Map.CapabilitiesHeader = XMLHttp.getAllResponseHeaders();
        var XML = new XMLUtil();
        //prompt('',Map.GetCapabilities());
        //alert(XMLHttp.getResponseHeader("Content-Type"));
        //if (XMLHttp.getResponseHeader("Content-Type")!="text/xml"){
            var XMLErr;
            var XMLDOC = new XMLDoc(XMLHttp.responseText,XMLErr);
            Map.Capabilities = XMLDOC.docNode;
        //}
        //~~~~~~~~~~~~~~~~~~~~~~~~~
        //Extrack Map Properties
        var XMap = Map.Capabilities.getElementsByTagName('Layer')[0];
        Map.Name = XML.GetValueElement(XMap,'Name');
        Map.Title = XML.GetValueElement(XMap,'Title');
        var XBBOX = XML.GetDeepestElement(XMap,'LatLonBoundingBox');
        var LayerXmin=-180;var LayerXmax=180;var LayerYmin=-90; var LayerYmax=90;
        if (XBBOX!=null){
            var LayerXmin = parseFloat(XBBOX.getAttribute('minx'));
            var LayerXmax = parseFloat(XBBOX.getAttribute('maxx'));
            var LayerYmin = parseFloat(XBBOX.getAttribute('miny'));
            var LayerYmax = parseFloat(XBBOX.getAttribute('maxy'));
        }
        Map.DefaultExtent = new Rect(LayerXmin,LayerYmin,LayerXmax,LayerYmax);
        Map.Extent = new Rect(LayerXmin,LayerYmin,LayerXmax,LayerYmax);
        
        //Extrack Getmap Format
        var XGetMap = Map.Capabilities.getElementsByTagName('GetMap')[0];
        var XFormats = XML.GetDeepestElements(XGetMap,'Format');
        if (XFormats.length>0){
            for (var j=0;j<XFormats.length;j++){
                Map.GetMapFormats.push(XFormats[j].getText());
            }
            //Map.GetMapFormat = Map.GetMapFormats[0];
            Map.GetMapFormat = Map.AutoMapFormat();
        }

        //~~~~~~~~~~~~~~~~~~~~~~~~~
        //Extrack Layers Properties
        var ELayers = new Array();
        var XLayers = XML.GetDeepestElements(Map.Capabilities,'Layer');
        Map.Layers = new Array();
        for(var i=0;i<XLayers.length;i++)
        {
            var XLayer = XLayers[i]; 
            var MLayer = new Layer("","",true,true,true);
            MLayer.Title = XML.GetValueElement(XLayer,'Title');
            MLayer.Name = XML.GetValueElement(XLayer,'Name');
            MLayer.Abstract = XML.GetValueElement(XLayer,'Abstract');
            MLayer.Queryable = (XLayer.getAttribute('queryable')=="1");
            MLayer.Opaque = (XLayer.getAttribute('opaque')=="1");
            MLayer.Cascaded = (XLayer.getAttribute('cascaded')=="1");
            //-------------
            //Secret Spetial Effect
            if (MLayer.Opaque){Map.InvisibleUnderLayer(i);};
            if (MLayer.Title.substring(0,1)=="~"){
                MLayer.Visible=false;
                MLayer.Title = MLayer.Title.substring(1,MLayer.Title.length);
            }
            //-------------
            //Detect Layer Projection
            MLayer.SRS = new Array();
            var XSRS = XML.GetDeepestElements(XLayer,'SRS');
            if (XSRS.length>0){
                for (var j=0;j<XSRS.length;j++){
                    MLayer.SRS.push(XSRS[j].getText());
                }
                Map.SRSs = MLayer.SRS;
            }else{
                MLayer.SRS.push("EPSG:4326");
                Map.SRSs = MLayer.SRS;
            }
            //-------------
            var XStyle = XML.GetDeepestElements(XLayer,'Style');
            MLayer.Styles = new Array();
            if (XStyle.length>0){
                for (var j=0;j<XStyle.length;j++){
                    MLayer.Styles.push(XML.GetValueElement(XStyle[j],'Name'));
                }
            }else{
                MLayer.Styles.push('default');
            }
            MLayer.Style = MLayer.Styles[0];
            //-------------
            var XBBOX = XML.GetDeepestElement(XLayer,'LatLonBoundingBox');
            if (XBBOX!=null){
                var LayerXmin = parseFloat(XBBOX.getAttribute('minx'));
                var LayerXmax = parseFloat(XBBOX.getAttribute('maxx'));
                var LayerYmin = parseFloat(XBBOX.getAttribute('miny'));
                var LayerYmax = parseFloat(XBBOX.getAttribute('maxy'));
                MLayer.Extent = new Rect(LayerXmin,LayerYmin,LayerXmax,LayerYmax);
            }else{
                MLayer.Extent = Map.Extent.Clone();
            }
            if (MLayer.Title.substring(0,1)!="#"){
                Map.Layers.push(MLayer);
            }
            if (Map.Layers.length>=Map.LayerLimit){break;}
        }
        //Release Event in Eventhandle.js
        if (Map.OnLoadCapabilities!=null){Map.OnLoadCapabilities(Map)}
    }
    //-------------------------------------
    function WMS_GetFeatureInfo(){
        if (this.QueryShape!=null && this.GetLayerActive()!=null){
            var Request = this.MapServer ;
            Request += '&Service=WMS';
            Request += '&Version=1.1.1';
            Request += '&Request=GetFeatureInfo';
            Request += '&SRS='+this.SRS;
            //Request += '&INFO_FORMAT=application/vnd.ogc.gml';
            Request += '&INFO_FORMAT=text/plain';
            Request += '&BBOX='+this.Extent.toString('%2c') ;
            Request += '&Width='+this.ImgSize.X;
            Request += '&Height='+this.ImgSize.Y;
            Request += '&X='+this.ImgPositionX(this.QueryShape.X);
            Request += '&Y='+this.ImgPositionY(this.QueryShape.Y);
            Request += this.QueryOptions;
            Request += '&Layers='+this.VLayers('%2c');
            //Request += '&Query_Layers='+this.QLayers('%2c');
            Request += '&Query_Layers='+this.GetLayerActive().Name;
            return Request;
        }else{
            return null;
        }
    }
    function WMS_AutoMapFormat(){
        var Priority = new Array();
        Priority.push("image/png; mode=24bit");
        Priority.push("image/gif");
        Priority.push("image/jpeg");
        Priority.push("image/png");
        for (var i=0; i<Priority.length; i++){
            var PrioMapFormat = new String(Priority[i]);
            PrioMapFormat = PrioMapFormat.toLowerCase();
            for (var j=0; j<this.GetMapFormats.length; j++){
                var GetMapFormat = new String(this.GetMapFormats[j]);
                GetMapFormat = GetMapFormat.toLowerCase();
                if (PrioMapFormat==GetMapFormat){return PrioMapFormat;}
            }
            
        }
        return this.GetMapFormats[0];
    }
    
    //=================================================================
    //               MapServ Connector
    //=================================================================
    function MapServer_GetMap(){
        var    Result = this.MapServer ;
        Result += '&Map_Interlace=OFF';
        Result += '&Map_ImageType=JPEG';
        Result += '&MAP_EXTENT=' + this.Extent.toString('+') ;
        Result += '&MAP_SIZE='+this.ImgSize.X+'+'+this.ImgSize.Y;
        if (this.QueryShape!=null){
            Result += '&Mode=NQueryMap';
            Result += '&MAP_QUERYMAP_SIZE='+this.ImgSize.X+'+'+this.ImgSize.Y;
            Result += "&MapSize="+this.ImgSize.X+"+"+this.ImgSize.Y;
            Result += "&ImgExt="+this.Extent.toString('+');
            Result += "&Img.X="+this.ImgPositionX(this.QueryShape.X);
            Result += "&Img.Y="+this.ImgPositionY(this.QueryShape.Y);
            //Result += "&ZoomDir=
            /*
            Result += '&MapXY='+this.QueryShape.X+'+'+this.QueryShape.Y;
            Result += '&MAP_QUERYMAP_SIZE='+this.ImgSize.X+'+'+this.ImgSize.Y;
            Result += '&QLayer='+this.QLayers('+');
            Result += '&SLayer='+this.SLayers('+');
            //Result += '&SRS=EPSG:24047';
            */
            Result += this.QueryOptions;
        }else{
            Result += '&Mode=Map';
            Result += '&Layers='+this.VLayers('+');
            Result += this.MapOptions;
        }
        return(Result);
    }

    function MapServer_GetFeatureInfo(){
        var    Request = this.QueryServer ;
        if (this.QueryShape!=null){
            Request += "&Mode=NQuery";
            Result  += '&MAP_QUERYMAP_SIZE='+this.ImgSize.X+'+'+this.ImgSize.Y;        
            Request += "&MapSize="+this.ImgSize.X+"+"+this.ImgSize.Y;
            Request += "&ImgExt="+this.Extent.toString('+');
            Request += "&Img.X="+this.ImgPositionX(this.QueryShape.X);
            Request += "&Img.Y="+this.ImgPositionY(this.QueryShape.Y);
            /*
            Request += '&Service=WMS';
            Request += '&Version=1.1.1';
            Request += '&Request=GetFeatureInfo';
            Request += '&INFO_FORMAT=GML';
            Request += '&BBOX='+this.Extent.toString('%2c') ;
            Request += '&Width='+this.ImgSize.X;
            Request += '&Height='+this.ImgSize.Y;
            Request += '&X='+this.ImgPositionX(this.QueryShape.X);
            Request += '&Y='+this.ImgPositionY(this.QueryShape.Y);
            Request += this.QueryOptions;
            Request += '&Layers='+this.VLayers('%2c');
            Request += '&Query_Layers='+this.QLayers('%2c');
            */
        }
        //fscommand('alert',Request);
        return(Request);
    }
        /*switch(this.Mode){
            case "Query": //
                if (this.QLayers(',')!=null){
                    Request =    Request + "&Request=GetFeatureInfo" +
                                '&X='+this.QueryShape.X +
                                '&Y='+this.QueryShape.Y +
                                '&QUERY_LAYERS='+this.QLayers(',');
                }
                if (this.QueryOptions!=null){
                    Request =    Request + this.QueryOptions
                }
                break;
            default : // Default Is Map Mode
               break;
        }*/
